@echo off
SETLOCAL EnableDelayedExpansion

SET "foundIPHelperService=0"



:: We need administrator rights
net session >nul 2>&1

if %ErrorLevel% NEQ 0 (
    echo Fatal Error: This script requires administrator privileges!
    pause
    GOTO :EOF
)


echo Enabling the Performance Counter in the registry...
Reg add HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\PerfProc\Performance /v "Disable Performance Counters" /t REG_DWORD /d 0 /f >nul 2>&1

if %ErrorLevel% NEQ 0 (
    echo FATAL ERROR: Could not write the registry key!
    pause
    GOTO :EOF
) else (
    echo ... successfully added the registry key
)


echo.
echo Registering the Performance Counter...
%windir%\system32\lodctr /R >nul 2>&1

:: This may fail on the first execution
:: So just try again
if %ErrorLevel% NEQ 0 (
    %windir%\system32\lodctr /R >nul 2>&1
)

:: Second try still failed
if %ErrorLevel% NEQ 0 (
    echo FATAL ERROR: Could not register the Performance Counter for system32
    pause
    GOTO :EOF
) else (
    echo ... successfully registered for system32
)


%windir%\sysWOW64\lodctr /R >nul 2>&1

:: This may fail on the first execution aswell?
:: So just try again
if %ErrorLevel% NEQ 0 (
    %windir%\sysWOW64\lodctr /R >nul 2>&1
)

if %ErrorLevel% NEQ 0 (
    echo FATAL ERROR: Could not register the Performance Counter for sysWOW64
    pause
    GOTO :EOF
) else (
    echo ... successfully registered for sysWOW64
)

echo.
echo Resyncing the Performance Counter...
%windir%\system32\wbem\winmgmt.exe /resyncperf >nul 2>&1

if %ErrorLevel% NEQ 0 (
    echo FATAL ERROR: Could not resync the Performance Counter!
    pause
    GOTO :EOF
) else (
    echo ... successfully synced
)





:: We may also need to stop the iphlpsvc service

:: ErrorLevels for FINDSTR
:: 0: The search was completed successfully and at least one match was found
:: 1: The search was completed successfully, but no matches were found
:: 2: The search was not completed successfully (wrong syntax)
:: An invalid switch will only print an error message in error stream
call wmic /locale:ms_409 service where (name="iphlpsvc") get state /value | findstr /I /C:"State=Running" >nul

:: The iphlpsvc is running, stop it and set a flag to re-enable it later
if %ErrorLevel% EQU 0 (
    SET "foundIPHelperService=1"
)


if "%foundIPHelperService%" == "1" (
    echo.
    echo Stopping the IP Helper service...
    net stop iphlpsvc >nul 2>&1

    if %ErrorLevel% NEQ 0 (
        echo FATAL ERROR: Could not stop the IP Helper service!
        pause
        GOTO :EOF
    ) else (
        echo ... successfully stopped
    )
)


echo.
echo Stopping and restarting the Windows Management Instrumentation service...
net stop winmgmt >nul 2>&1

if %ErrorLevel% NEQ 0 (
    echo FATAL ERROR: Could not stop the Windows Management Instrumentation service!
    pause
    GOTO :EOF
) else (
    echo ... successfully stopped
)

net start winmgmt >nul 2>&1

if %ErrorLevel% NEQ 0 (
    echo FATAL ERROR: Could not start the Windows Management Instrumentation service!
    pause
    GOTO :EOF
) else (
    echo ... successfully restarted
)


:: Restart the iphlpsvc service
if "%foundIPHelperService%" == "1" (
    echo.
    echo Starting the IP Helper service...
    net start iphlpsvc >nul 2>&1

    if %ErrorLevel% NEQ 0 (
        echo FATAL ERROR: Could not start the IP Helper service!
        pause
        GOTO :EOF
    ) else (
        echo ... successfully restarted
    )
)

pause